NAME
        maysim - mulateur pour l'ordinateur MAYBE

SYNOPSIS
        maysim [-option|assignation...]

DESCRIPTION
        Le programme maysim est un mulateur interactif permettant de
        tester le fonctionnement de programmes prvus pour l'ordinateur
        MAYBE. Il fonctionne sous la version SUN de UNIX.
	
FUNCTIONS
	Les remarques qui suivent s'appliquent aussi bien  une fonction
	appele depuis la ligne de commande qu'en mode interactif.

	go	la commande go excute des instructions de MAYBE
		jusqu' atteindre un breakpoint, une instruction errone
		ou un nombre limite de nano-steps. Si on souhaite supprimer
		cette limite, il faut la spcifier nulle. Ds lors, la
		protection qu'elle offre contre les boucles mal termines
		disparait.

	valeurs	lorsqu'une valeur doit tre entre, elle peut prendre trois
		formes : un nombre dcimal, un nombre hexadcimal suivi de 'h'
		ou encore un nombre binaire suivi de 'b'.
		Les valeurs sont toujours positives, sans signe '+' ou '-'.
		La plupart des fonctions prennent une valeur par dfaut lorsque
		l'utilisateur ne spcifie rien.

OPTIONS
	Toutes les options sont inactives par dfaut.
	L'ordre des options n'est pas indiffrent: elles sont values de
	gauche  droite.

	-?	Affiche le message d'aide concernant la ligne de commande.

	-ow	Ouvre ds le lancement une fentre de type "w" o "w" peut
		tre c, d, m, r, u ou s, c'est--dire une fentre CtlRom,
		DRAM, MicroROM, Register, UART ou SRAM.

	-rwfile	Lit dans la mmoire de type "w" le contenu du fichier "file".
		"w" peut tre c, d, m ou s.

	-wwfile Ecrit la mmoire de type "w" dans le fichier "file".
		Si file n'est pas spcifi, le rsultat est affich
		sur STDOUT.

	-w	Cette option est ncessaire lorsque la largeur de la
		console utilise dpasse 80 colonnes ou lorsque le
		passage automatique  la ligne n'y est pas actif.

	-hnn	Cette option force MAYSIM  utiliser nn comme hauteur
		d'cran. Elle a priorit sur la hauteur dtermine
		automatiquement au dmarrage. Elle n'a aucun effet sur la
		taille de la fentre mre, elle limite seulement les
		sous-fentres gnres par MAYSIM.

	-gnn	Cette option force MAYSIM  effectuer un maximum de nn
		nano-steps au dmarrage. Elle empche le passage au mode
		interactif sauf si -i ou -o est spcifi.
		Si nn n'est pas spcifi, une valeur par dfaut est utilise.

	-i	Cette option force MAYSIM  repasser en mode interactif
		mme si l'option -g est employe.

	-bnn	Cette option permet d'arrter la simulation avant l'excution
		de la microinstruction de code nn. Elle n'affecte pas un -g
		qui la prcderait.

ASSIGNMENTS
	La ligne de commande peut comporter des assignations.
	Celles-ci sont constitues d'un membre de gauche et d'un membre de
	droite spars par le signe '='.
	Le membre de droite est une valeur (voir plus haut).
	Le membre de gauche est un des noms symboliques suivants:
		A B CCR PC SW B0 B1
	Les majuscules et les minuscules ne sont pas quivalentes.

COMMANDS
	Ces commandes sont disponibles une fois que le programme est pass
	en mode interactif.  Certaines d'entre elles doivent tre prcdes
	du prfixe "Meta" (en gnral Ctrl-X).  Toutes les fonctions peuvent
	tre obtenues  partir d'un clavier ASCII.  Toutefois, si la console
	utilise dispose de touches spciales, il est ncessaire de possder
	un fichier de configuration pour les utiliser.

	Certaines commandes demandent un complment d'information (par exemple,
	une valeur numrique ou un nom de fichier). Cette information est entre
	sur la dernire ligne et peut tre dite. De telles commandes peuvent
	tre interrompues  ce stade par Ctrl-G.

	Il y a trois groupes de commandes: celles lies au fentrage en gnral,
	celles lies a MAYBE et celles lies  une fentre particulire.
	Ces dernires ne sont accessibles que lorsque le curseur se trouve dans
	la fentre en question.

	Voyez l'aide en ligne pour savoir si une touche spciale appelle une
	fonction donne sur votre machine.

	Commandes de fentrage:

		Aide en ligne		?
			affiche les touches lies aux diffrentes commandes

		Sortie			Ctrl-Q
			quitte MAYSIM

		Ouverture		Ctrl-O
			appelle un sous-menu demandant quelle fentre ouvrir
			sauf s'il n'y a dj plus place  l'cran.

		Fermeture		Ctrl-K

		Agrandissement		Meta-+
			agrandit d'une ligne s'il reste de la place.

		Rduction		Meta--
			rduit d'une ligne (non disponible en mode fentre
			unique)

		Zoom			Ctrl-Z
			S'il reste de la place  l'cran, on agrandit la
			fentre courante, sinon on passe en mode fentre unique.

		Raffichage		Ctrl-L

		Home			Ctrl-A
			Va d'abord en dbut de ligne. Si on y est dja,
			va en dbut de fentre. Si on y est dj, va au
			dbut de la fentre prcdente

		End			Ctrl-E
			Va en fin de fentre. Si on y est dj, va en fin
			de fentre suivante.

	Commandes de MAYBE:
		Micro-step		Enter
		Nano-step		Meta-S
		Go			Meta-G
		Set/clear breakpoint	Meta-B

		Boutons			Meta-0, Meta-1
		Switches		Meta-D
		Reset			Meta-R

		Lecture de fichiers	Ctrl-R
		Ecriture de fichiers	Ctrl-W

	Commandes lies  la fentre "registres hard":
		Registre A		A
		Registre B		B
		Registre de condition	C
			notons que les conditions tant des variables
			dpendantes, elles ne peuvent tre changes: seul le
			registre de condition peut l'tre.

		Numro d'opcode		O
		Phase			P
		Program counter		Jump

	Commandes lies  la fentre "UART":
		Set register		S
			appelle un sous-menu demandant quel registre changer

		Rception R
			simule la rception de la touche suivante par l'UART

	Commandes lies aux fentres mmoire:
		Ces commandes s'appliquent  la ram statique et dynamique
		ainsi qu' la rom microcode. Il y a des restrictions
		pour la rom nanocode.	

		Positionnement
			avance d'une ligne	+
			recule d'une ligne	-
			avance d'une page	>
			recule d'une page	<
			premire donne		Meta-<
			dernire donne		Meta->
			adresse			=

		Edition
			Mode hexa: 0..9 et A..F sont accepts sur les donnes
			Mode binaire: 0 et 1 sont accepts
			Passage d'un mode  l'autre: espace
			On ne peut pas modifier la rom de nanocode directement.

		Tracking
			Le tracking est un positionnement automatique du
			contenu des fentres mmoires.
			On passe du mode tracking en mode fixe et inversment
			au moyen de la touche 'T'.
			Pour la rom microcode: tracking sur PC
			Pour la rom nanocode: tracking sur les nano-steps
			Pour la ram statique: tracking sur un de ses propres
				registres au choix, par exemple SP=254

TROUBLESHOOTING
	Certains problmes peuvent survenir  cause de l'inclusion de la
	librairie CURSES. Celle-ci peut prsenter des anomalies de
	fonctionnement si l'environnement graphique n'est pas configur
	impeccablement.

	Si l'affichage n'est pas configur correctement, il est hautement
	recommand de ne pas utiliser l'dition de la mmoire.  L'emplacement
	effectif des modifications risquerait de ne pas correspondre aux
	adresses affiches. Les autres fonctions du simulateur ne sont pas
	affectes.

	Si le dbut de la ligne qui devrait suivre le titre d'une fentre
	apparait en fait  sa droite, utiliser l'option -w.

	Si au contraire il y a une ligne blanche entre la ligne de titre et
	la premire ligne de donnes, ne pas utiliser l'option -w, vrifier
	qu'elle n'est pas prsente dans l'ventuel script invoquant le
	simulateur.

	Certains environnements rcuprent F1 pour leur propre usage; l'aide
	en ligne reste disponible, utiliser '?' pour l'obtenir.

	Le simulateur lit la taille du terminal virtuel depuis lequel il est
	lanc, mais ne suit pas les changement de tailles postrieurs. Il est
	dconseill de modifier la taille fixe initialement.

	Lorsque la version utilisant le clavier Sun est utilise depuis un
	xterm, ne pas oublier l'option -sf de xterm, sous peine de perdre les
	touches de fonction.

	Mme si le clavier est mal configur, toutes les fonctions du simulateur
	restent accessibles au moyen des sequences Ctrl- ou Meta-.

	Dans les cas dsesprs, il reste la possibilit de lancer le simulateur
	directement de la console, ou encore de se contenter du mode batch.

